// Copyright 2024 The Kubeflow Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/kubeflow/training-operator/pkg/apis/kubeflow.org/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// PyTorchJobLister helps list PyTorchJobs.
// All objects returned here must be treated as read-only.
type PyTorchJobLister interface {
	// List lists all PyTorchJobs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.PyTorchJob, err error)
	// PyTorchJobs returns an object that can list and get PyTorchJobs.
	PyTorchJobs(namespace string) PyTorchJobNamespaceLister
	PyTorchJobListerExpansion
}

// pyTorchJobLister implements the PyTorchJobLister interface.
type pyTorchJobLister struct {
	listers.ResourceIndexer[*v1.PyTorchJob]
}

// NewPyTorchJobLister returns a new PyTorchJobLister.
func NewPyTorchJobLister(indexer cache.Indexer) PyTorchJobLister {
	return &pyTorchJobLister{listers.New[*v1.PyTorchJob](indexer, v1.Resource("pytorchjob"))}
}

// PyTorchJobs returns an object that can list and get PyTorchJobs.
func (s *pyTorchJobLister) PyTorchJobs(namespace string) PyTorchJobNamespaceLister {
	return pyTorchJobNamespaceLister{listers.NewNamespaced[*v1.PyTorchJob](s.ResourceIndexer, namespace)}
}

// PyTorchJobNamespaceLister helps list and get PyTorchJobs.
// All objects returned here must be treated as read-only.
type PyTorchJobNamespaceLister interface {
	// List lists all PyTorchJobs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.PyTorchJob, err error)
	// Get retrieves the PyTorchJob from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1.PyTorchJob, error)
	PyTorchJobNamespaceListerExpansion
}

// pyTorchJobNamespaceLister implements the PyTorchJobNamespaceLister
// interface.
type pyTorchJobNamespaceLister struct {
	listers.ResourceIndexer[*v1.PyTorchJob]
}
