// Copyright 2024 The Kubeflow Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "github.com/kubeflow/training-operator/pkg/apis/kubeflow.org/v1"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
)

// XGBoostJobLister helps list XGBoostJobs.
// All objects returned here must be treated as read-only.
type XGBoostJobLister interface {
	// List lists all XGBoostJobs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.XGBoostJob, err error)
	// XGBoostJobs returns an object that can list and get XGBoostJobs.
	XGBoostJobs(namespace string) XGBoostJobNamespaceLister
	XGBoostJobListerExpansion
}

// xGBoostJobLister implements the XGBoostJobLister interface.
type xGBoostJobLister struct {
	listers.ResourceIndexer[*v1.XGBoostJob]
}

// NewXGBoostJobLister returns a new XGBoostJobLister.
func NewXGBoostJobLister(indexer cache.Indexer) XGBoostJobLister {
	return &xGBoostJobLister{listers.New[*v1.XGBoostJob](indexer, v1.Resource("xgboostjob"))}
}

// XGBoostJobs returns an object that can list and get XGBoostJobs.
func (s *xGBoostJobLister) XGBoostJobs(namespace string) XGBoostJobNamespaceLister {
	return xGBoostJobNamespaceLister{listers.NewNamespaced[*v1.XGBoostJob](s.ResourceIndexer, namespace)}
}

// XGBoostJobNamespaceLister helps list and get XGBoostJobs.
// All objects returned here must be treated as read-only.
type XGBoostJobNamespaceLister interface {
	// List lists all XGBoostJobs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1.XGBoostJob, err error)
	// Get retrieves the XGBoostJob from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1.XGBoostJob, error)
	XGBoostJobNamespaceListerExpansion
}

// xGBoostJobNamespaceLister implements the XGBoostJobNamespaceLister
// interface.
type xGBoostJobNamespaceLister struct {
	listers.ResourceIndexer[*v1.XGBoostJob]
}
